/*
 * Copyright 2004-2006 The Distributed Software Systems Group,
 *                     University of Massachusetts, Boston
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * If you have any questions on this source code, see
 * http://dssg.cs.umb.edu/ or email Jun Suzuki at jxs@cs.umb.edu.
 */

package edu.umb.cs.umlvm.core.blackboard.data;

import org.eclipse.uml2.Model;

import edu.umb.cs.umlvm.core.util.UML2Util;

public class UMLTree extends Data {

    public UMLTree() {
    }
    
    public UMLTree(Model model) {
        setObject(model);
    }

    public void discard() {
        if (getObject() != null) {
            Model model = (Model) getObject();
            UML2Util.unload( model );
        }
        setObject( null );
    }
}
